unsigned char chk_busy;
unsigned char i,ch;

//-- A hardverfgg rszletek elklntse
#define RSHIGH()         LATD |= 0x01;
#define RSLOW()          LATD &= 0xFE;
#define RWHIGH()         LATD |= 0x02;
#define RWLOW()          LATD &= 0xFD;
#define EHIGH()          LATD |= 0x04;
#define ELOW()           LATD &= 0xFB;
#define BUSY_FLAG PORTDbits.RD7;
#define DATA_DIR_RD()    TRISDbits.TRISD4 = 1; TRISDbits.TRISD5 = 1;  TRISDbits.TRISD6 = 1; TRISDbits.TRISD7 = 1;
#define DATA_DIR_WR()    TRISDbits.TRISD4 = 0; TRISDbits.TRISD5 = 0;  TRISDbits.TRISD6 = 0; TRISDbits.TRISD7 = 0;
#define OUTPUT_DATA(x) {LATD = (LATD & 0x0F) | x;} //4 als bit magas szintre

//-- Az E vezrljel pulzlsa 
void epulse(void){
    Delay10TCYx(2);  
    EHIGH();  Delay10TCYx(2); 
    ELOW(); Delay10TCYx(1);
}

//-- Egy bjt (parancs vagy adat) kirsa
void lcd_write(unsigned char cmd, unsigned char data_flag, unsigned char chk_busy, unsigned char dflag){
	char bflag,c;
	if(chk_busy){
		RSLOW();                 //RS = 0 a foglaltsg figyelshez
		DATA_DIR_RD();           //adatvonalak vtelre lltsa
		RWHIGH();                //R/W = 1 olvasshoz
		do{
			EHIGH(); 
			Delay10TCYx(2);
			bflag = BUSY_FLAG;     //fels 4 bit olvassa
			ELOW(); Delay10TCYx(2);
			epulse();              //als flbjt kilptetse
		}while(bflag);
	}else{
		Delay10KTCYx(12);        //Foglaltsg figyels helyett ksleltets
	}
	DATA_DIR_WR();             //Adatvonalak rsra lltsa
	if(data_flag){ 
		RSHIGH();                //RS=1, ha adatklds kvetkezik
	}
	else RSLOW();              //RS=0, ha parancsot kldnk
		RWLOW();                   //R/W = 0, rshoz
	c = cmd & 0xF0;            //fels 4 bit kirsa
	OUTPUT_DATA(c);
	epulse();
	if(dflag){
		c = (cmd & 0x0F)<<4;     //als 4 bit kirsa
		OUTPUT_DATA(c);
		epulse();
	}
}

//-- Az LCD modul inicializlsa
void lcd_init(void) {
	//-- Az LCD-t vezrl vonalak inicializlsa
	DATA_DIR_WR();
	ELOW();
	RSLOW();
	RWLOW(); 
	//-- Az LCD modul szoftveres reset-else s inicializlsa
	Delay10KTCYx(60);          //50 ms vrakozs az LCD felledsre 
	lcd_write(0x30,0,0,0);     //8 bites zemmd      
	Delay10KTCYx(6);           //5 ms vrakozs
	lcd_write(0x30,0,0,0);     // 4 bites zemmd
	lcd_write(0x30,0,0,0);     // 8 bites zemmd
	lcd_write(0x20,0,0,0);     // 4 bites zemmdba kapcsolunk
	//-- Innen kezdve a 4 bites zemmd l (kldsnl dflag=1 kell)
	lcd_write(0x28,0,0,1);     // 2 soros display, 5x7 font
	//-- Innen kezdve figyelhet a BF jelzbit (chk_busy=1)
	lcd_write(0x08,0,1,1);     // display letilts
	lcd_write(0x01,0,1,1);     // kpernytrls
	lcd_write(0x0C,0,1,1);     // display be, cursor, s villogs ki
	stdout = _H_USER;          // a felhasznli fggvny legyen a
                               // standard kimenet, ami az LCD-re r
}

//-- LCD-re egy karaktert kir fggvny a _H_USER stream szmra
void _user_putc(char cx) {
    lcd_write(cx,1,1,1);
}

//ROM-ban trolt stringek kiratsra
void RomStringWrite(const rom static unsigned char * pszovegek){
	char c_h;
	do{
		c_h =  *pszovegek;
		if (c_h) _user_putc(c_h);
		*pszovegek++;
	}while (c_h!=0);
}

void epulse(void);
void lcd_write(unsigned char cmd, unsigned char data_flag, unsigned char chk_busy, unsigned char dflag);
void lcd_init(void);
void lcd_init_cgram(void);
void _user_putc(char cx);
void RomStringWrite(const rom static unsigned char * pszovegek);
